// 指定したフォルダ・サブフォルダ内にあるファイルサイズをレポート
(function (){
	var checkFolder = Folder.selectDialog("ファイルサイズを調べるフォルダを選択してください");
	if (!checkFolder){ return; }	// キャンセルした場合は何もしない
	var fileList = getFilesX("*", checkFolder, { japanese: true });	// 全てのファイルが対象
	if (fileList.length < 1){
		alert("フォルダにファイルがありません");
		return;
	}
	var f = File.saveDialog("結果を保存するファイル名を指定してください");
	if (!f){ return; }
	var flag = f.open("w");
	if (!flag){ return; }
	var total = 0;
	var total2 = 0;
	for(var i=0; i<fileList.length; i++){
		var _byte = fileList[i].length;
		if (_byte){
			total = total + _byte;	// フォルダ内の合計サイズ
			if (_byte > 0){	// ファイルサイズチェック
				f.writeln(fileList[i].nameJ+" ("+_byte+"バイト)");
				total2 = total2 + _byte;	// 対象ファイルだけの合計
			}
		}
	}
	f.writeln("合計バイト数：　　　　　　　"+total+"バイト");
	f.writeln("対象ファイルの合計バイト数："+total2+"バイト");
	f.close();
})();
// サブフォルダ内にあるファイルも取得する
function getFilesX(fileTypes, basePath,options){
		options = options || {};
		if(!basePath){
			basePath = Folder.selectDialog("フォルダを選択してください");
			if (!basePath){ return; }	// キャンセルされた場合は処理しない
		}
		var allList = [];
		// パラメータが文字の場合
		if (typeof(fileTypes) == "string"){
			getFileList(new Folder(basePath), fileTypes);
			return toJapanese(allList, options.japanese);
		}
		// パラメータが配列の場合
		if (fileTypes.push){
			for(var i=0; i<fileTypes.length; i++){
				getFileList(new Folder(basePath), fileTypes[i]);
			}
			return toJapanese(allList, options.japanese);
		}
		function getFileList(currentFolder, fileType){
			var fileList = currentFolder.getFiles(fileType);
			var fileList2 = currentFolder.getFiles("*");	// Sub Folder
			allList = allList.concat(fileList);
			for(var i=0; i<fileList2.length; i++){
				if (fileList2[i].getFiles){
					if (fileList2[i].name.charAt(0) == "."){ continue; }
					getFileList(fileList2[i], fileType);	// フォルダがある限り繰り返し
				}
			}
		}
		// 日本語に変換(nameJ, fullNameJ)
		function toJapanese(fileList, flag){
			if (!flag){ return fileList; }
			for(var i=0; i<fileList.length; i++){
				fileList[i].nameJ = File.decode(fileList[i].name);
				fileList[i].fullNameJ = File.decode(fileList[i].fullName);
				//$.writeln(">>"+fileList[i].nameJ);
			}
			return fileList;
		}
	}